#!/usr/bin/bash


if [ ! $1 ] || [ ! $2 ]; then
	echo "usage: $0 file1 file"
	exit
fi


if [ ! -f "$1" ];  then
	echo "$1 - file does not exist"
	exit
fi

if [ ! -f "$2" ];  then
	echo "$2 - file does not exist"
	exit
fi


FILE_ONE_WITHC=`tr -d [:blank:] < $1`
FILE_TWO_WITHC=`tr -d [:blank:] < $2`


FILE_ONE_NOC=`tr -d [:blank:] < $1 | nawk -F '#' '{print $1}'`
FILE_TWO_NOC=`tr -d [:blank:] < $2 | nawk -F '#' '{print $1}'`


LINES_MATCHING=0
LINES_TOTAL=0

declare -a ARRAY_FILE_ONE_WITHC
declare -a ARRAY_FILE_TWO_WITHC

I=0
for LINE_ONE in $FILE_ONE_WITHC
do
	ARRAY_FILE_ONE_WITHC[$I]=$LINE_ONE
	let "I+=1"
done

I=0
for LINE_TWO in $FILE_TWO_WITHC
do
	ARRAY_FILE_TWO_WITHC[$I]=$LINE_TWO
	let "I+=1"
done

for LINE_ONE in ${ARRAY_FILE_ONE_WITHC[@]}
do

	let "I=0"

	for LINE_TWO in ${ARRAY_FILE_TWO_WITHC[@]}
	do
	
		if [ $LINE_ONE = $LINE_TWO ]
		then
			let "LINES_MATCHING+=1"
			ARRAY_FILE_TWO_WITHC[$I]="\t# "	#make this line equal something will never match
			break 1	# stop processing this line in file1
		fi
		
		let "I+=1"				
	
	done

	let "LINES_TOTAL+=1"
	
done

LINES_NOT_MATCHING=$(($LINES_TOTAL-$LINES_MATCHING))
PERCENT_NOT_MATCHING=`echo "scale=2; $LINES_NOT_MATCHING/$LINES_TOTAL*100" | bc | nawk -F '.' '{print $1}'`

echo "Total lines matched" $LINES_MATCHING
echo "Total lines not matched" $LINES_NOT_MATCHING
echo "Percentage of total lines different" $PERCENT_NOT_MATCHING"%"

LINES_MATCHING=0
LINES_TOTAL=0

declare -a ARRAY_FILE_ONE_NOC
declare -a ARRAY_FILE_TWO_NOC

I=0
for LINE_ONE in $FILE_ONE_NOC
do
	ARRAY_FILE_ONE_NOC[$I]=$LINE_ONE
	let "I+=1"
done

I=0
for LINE_TWO in $FILE_TWO_NOC
do
	ARRAY_FILE_TWO_NOC[$I]=$LINE_TWO
	let "I+=1"
done

for LINE_ONE in ${ARRAY_FILE_ONE_NOC[@]}
do
	
	let "I=0"

	for LINE_TWO in ${ARRAY_FILE_TWO_NOC[@]}
	do
	
		if [ $LINE_ONE = $LINE_TWO ]
		then
			let "LINES_MATCHING+=1"
			ARRAY_FILE_TWO_NOC[$I]="\t# "
			break 1	# stop processing this line in file1
		fi
			
		let "I+=1"	
	done

	let "LINES_TOTAL+=1"
	
done

LINES_NOT_MATCHING=$(($LINES_TOTAL-$LINES_MATCHING))
PERCENT_NOT_MATCHING=`echo "scale=2; $LINES_NOT_MATCHING/$LINES_TOTAL*100" | bc | nawk -F '.' '{print $1}'`

echo "Lines matched excluding comments" $LINES_MATCHING
echo "Lines not matched excluding comments" $LINES_NOT_MATCHING
echo "Percentage of lines different excluding comments" $PERCENT_NOT_MATCHING"%"
